from PySide import QtCore, QtGui
from abc import *
from math import *
from Pattern import *
from ColorPalette import *
import os

################################################################################
# pomocne funkcie

def modifieColor(rgb):
    color = QtGui.QColor(rgb)
    r = color.red()
    g = color.green()
    b = color.blue()
    r = r | 7
    g = g | 7
    b = b | 7
    #print(str(r)+"+"+str(g)+"+"+str(b))
    color = QtGui.QColor(r,g,b)
    return color.rgb()
    
def find_distance(rgb1,rgb2):
    color1 = QtGui.QColor(rgb1)
    color2 = QtGui.QColor(rgb2)
    r1 = color1.red()
    g1 = color1.green()
    b1 = color1.blue()
    r2 = color2.red()
    g2 = color2.green()
    b2 = color2.blue()
    vz = (r1-r2)*(r1-r2) + (g1-g2)*(g1-g2) + (b1-b2)*(b1-b2)
    return vz    
    
def doStatistics(image,palette):
    poc = {}
    zoz = {}
    vz = {}
    x = image.width()
    y = image.height()
    #print(str(x)+" "+str(y))
    for X in range(0,x):    #pre kazdy pixel v obrazku
        for Y in range(0,y):
            rgb = modifieColor(image.pixel(X,Y))
            id = palette.getNearestNumToRGBColor(rgb) #najdem najblizsiu farbu
            if(id in poc):
                poc[id] = poc[id]+1 #zapocitam si ju
            else:
                poc[id] = 1
                vz[id] = 0
                zoz[id] = []
            zoz[id].append(rgb)  #pripojim ju do zoznamu farieb pre najblizsiu farbu
            vzd = find_distance(rgb, palette.getColor(id)) #pripocitam stvorec vzdialenosti
            vz[id] = vz[id]+vzd    

    return poc,zoz,vz  
    
def JeV(width,height,x,y):
    if(x >= 0 and y >= 0 and x < width and y < height): return True
    return False     
                 

################################################################################
# vyberanie palety
 
def choose_colors_1(image,palette,max): 
    print("jednoduche")
    poc = doStatistics(image,palette)[0]
    
    #for id in poc.keys():
    #    print(str(id)+" "+str(poc[id]))
    
    retPalette = ColorPalette()
    for id in poc.keys():
        if poc[id] != 0:
            retPalette.addColor(id,palette.getColor(id))
    
    while len(poc.keys()) > max:
        min = image.width()*image.height()+47; #hladam najmenej pocetnu farbu
        minID = -1;
        for id in poc.keys():
            if poc[id] < min:
                min = poc[id]
                minID = id  
        retPalette.removeColor(minID) #vymazem ju        
                
        rgb = palette.getColor(minID)
        #rgb = modifieColor(rgb)
        id = retPalette.getNearestNumToRGBColor(rgb)        
        poc[id] = poc[id]+poc[minID] #jej pixely priradim k nej najblizsej farbe             
        poc.pop(minID)                
             
    return retPalette     
    
def choose_colors_2(image,palette,max):
    print("zlepsene")
    poc = doStatistics(image,palette)[0]
    
    retPalette = ColorPalette()        
    for id in poc.keys():
        if poc[id] != 0:
            retPalette.addColor(id,palette.getColor(id))
                 
    x = image.width()
    y = image.height()  
    
    pocPod = 0      
    while (len(poc.keys()) > max): 
        pocPod = pocPod + 1
        min = image.width()*image.height()+47; #hladam najmenej castu farbu
        minID = -1;
        for id in poc.keys():
            if poc[id] < min:
                min = poc[id]
                minID = id  
                       
        if(min/float(x*y) >= 0.01): break  # ako určiť ten koeficient?   0.01 ...   skoncim ked najdena farba ma viac ako 1 percento     
        retPalette.removeColor(minID)  #vymazem ju      
                
        rgb = palette.getColor(minID)
        #rgb = modifieColor(rgb)
        id = retPalette.getNearestNumToRGBColor(rgb) #pixely k nej prisluchajuce dam k nej najblizsej farbe        
        poc[id] = poc[id]+poc[minID]              
        poc.pop(minID)
     
    print("pod jednym percentom: "+str(pocPod))
        
    while (len(poc.keys()) > max): #ak mam stale vela farieb
        min = 256*256*256+47
        id1 = 0
        id2 = 1
        for n1 in poc.keys():
            for n2 in poc.keys():  #najdem dve najblizsie farby
                if n1 != n2:
                    vz = find_distance(retPalette.getColor(n1),retPalette.getColor(n2))
                    if(vz < min):
                        min = vz
                        id1 = n1
                        id2 = n2
                                                     
        if(poc[id1] > poc[id2]): #necham si tu castejsiu
            retPalette.removeColor(id2)
            poc[id1] = poc[id1] + poc[id2]
            poc.pop(id2)
        else:
            retPalette.removeColor(id1)
            poc[id2] = poc[id2] + poc[id1]
            poc.pop(id1)
    #print(retPalette.colors)        
    return retPalette    
    
def choose_colors_3(image,palette,max):
    print("rozdel")
    ret = doStatistics(image,palette)
    
    retPalette = ColorPalette()       
    for id in ret[0].keys():  #upratovanie
        if ret[0][id] != 0:
            retPalette.addColor(id,palette.getColor(id))
        else:
            ret[0].pop(id)
            ret[1].pop(id)
     
    x = image.width()
    y = image.height()  
    
    pocPod = 0      
    while (len(ret[0].keys()) > max):
        pocPod = pocPod + 1
        min = image.width()*image.height()+47; #vyhadzujem postupne farby, ktore su pod jednym percentom od najmenej castych
        minID = -1;
        for id in ret[0].keys():
            if ret[0][id] < min:
                min = ret[0][id]
                minID = id  
        if(min/float(x*y) >= 0.01): break  # ako určiť ten koeficient?   0.01
                
        rgb = retPalette.getColor(minID)
        #rgb = modifieColor(rgb)
        retPalette.removeColor(minID)
        
        #farby ktore patria pod najmensiu rozhadzem medzi zvysne farby          
        for k in range(0,len(ret[1][minID])):
            rgb = ret[1][minID][k]
            id = retPalette.getNearestNumToRGBColor(rgb)
            ret[0][id] = ret[0][id]+1 
            ret[1][id].append(rgb)
            ret[2][id] = ret[2][id] + find_distance(rgb,retPalette.getColor(id))
            
        for i in range(3):    
            ret[i].pop(minID)                          
         
    print("pod jednym percentom: "+str(pocPod))                    
    
    while (len(ret[0].keys()) > max):
        min = 256*256*256+47
        id1 = 0
        id2 = 1
        for n1 in ret[1].keys(): #hladam najblizsie farby
            for n2 in ret[1].keys():
                if n1 != n2:
                    vz = find_distance(retPalette.getColor(n1),retPalette.getColor(n2))
                    if(vz < min):
                        min = vz
                        id1 = n1
                        id2 = n2  
  
        retPalette.removeColor(id2) #vyskusam ako sa zvysi koef podobnosti (sucet stvorcov vzdialenosti) pre obe varianty
        vz1 = -ret[2][id2] #varianta... mazem id2
        for rgb in ret[1][id2]:
            id = retPalette.getNearestNumToRGBColor(rgb) 
            vz1 = vz1 + find_distance(rgb,retPalette.getColor(id))

        retPalette.addColor(id2,palette.getColor(id2))  
        
        retPalette.removeColor(id1) #varianta... mazem id1
        vz2 = -ret[2][id1]
        for rgb in ret[1][id1]:
            id = retPalette.getNearestNumToRGBColor(rgb)
            vz2 = vz2 + find_distance(rgb,retPalette.getColor(id))    
         
        #print(str(vz1)+" "+str(vz2))     
        if(vz1 < vz2) or ((vz1 == vz2)and (ret[0][id1] > ret[0][id1])): #zoberiem mensiu moznost a v pripade rovnosti zoberiem pocetnejsiu farbu                     
        #if(ret[0][num1] > ret[0][num1]) or ((vz1 < vz2) and (ret[0][num1] == ret[0][num2])):
            retPalette.addColor(id1,palette.getColor(id1))
            retPalette.removeColor(id2)
            for k in range(0,len(ret[1][id2])):
                rgb = ret[1][id2][k]
                id = retPalette.getNearestNumToRGBColor(rgb)
                ret[0][id] =  ret[0][id]+1 
                ret[1][id].append(rgb)
                ret[2][id] = ret[2][id] + find_distance(rgb,retPalette.getColor(id))
                
            for i in range(3):    
                ret[i].pop(id2)        
        else:
            for k in range(0,len(ret[1][id1])):
                rgb = ret[1][id1][k]
                id = retPalette.getNearestNumToRGBColor(rgb)
                ret[0][id] =  ret[0][id]+1 
                ret[1][id].append(rgb)
                ret[2][id] = ret[2][id] + find_distance(rgb,retPalette.getColor(id))
                
            for i in range(3):    
                ret[i].pop(id1)
                
    return retPalette         
    
################################################################################
# zmena velkosti obrazku    
    
def prepare_image_diam(image,square_size):     
    print("pripravujem obrazok")
    width = int((image.width()/square_size))
    height = int((image.height()/square_size))
    print(str(width)+" "+str(height))
    retImage = QtGui.QImage(width,height, QtGui.QImage.Format_ARGB32)    
    for i in range(0,height):
        for j in range(0,width):
            y1 = int(square_size*i)
            y2 = int(square_size*(i+1))
            if y1 == y2: y2 = y1+1
            x1 = int(square_size*j)
            x2 = int(square_size*(j+1))
            if x1 == x2: x2 = x1+1
            priemR = 0
            priemG = 0
            priemB = 0        # pocitam si vyskyty
            
            for y in range(y1,y2):
                for x in range(x1,x2):
                    color = QtGui.QColor(image.pixel(x,y))
                    r = color.red()
                    g = color.green()
                    b = color.blue()
                    priemR = priemR + r
                    priemG = priemG + g
                    priemB = priemB + b
            priemR = priemR/((y2-y1)*(x2-x1))        
            priemG = priemG/((y2-y1)*(x2-x1))
            priemB = priemB/((y2-y1)*(x2-x1))
            
             
            priemRGB = QtGui.QColor(priemR,priemG,priemB).rgb()
            retImage.setPixel(j,i,priemRGB)
    return retImage
    
def prepare_image_edge(image,square_size,zn): #plus = tmavsia strana hrany, minus = bledsia strana hrany
    print("zacal som")
    width = int((image.width()/square_size)) #rozmery vystupneho obrazku
    height = int((image.height()/square_size))
    
    #zoznam susedov, ktorí majú mať podľa filtru koeficient -1
    dx = [-1,0,1,-1,1,-1,0]  #aby som osetrila kraje, tak strednenu pixelu dam take cislo, kolko ma susedov
    dy = [-1,-1,-1,0,0,1,1]  #Preto stredny pixel spracuvam na zaver    
    
    #vstupne zn obasuje aj koeficient, aj znamienko... zn = koeficient*znamienko
    #ak zn = 0, tak chcem robit priemer, keď za znamienko necham 0, tak laplacian filter spraví celocierny obrazok a teda iba cisty priemer
    koef = abs(zn) 
    if koef != 0: zn = zn//koef
    
    max = 256
    min = 256//pow(2,koef)
    
    retImage = QtGui.QImage(width,height, QtGui.QImage.Format_ARGB32)
    for i in range(0,height):
        for j in range(0,width):
            #pocitanie hranic oblasti, ktora patri pod jeden vystupny pixel na pozicii [j,i]
            y1 = int(square_size*i) 
            y2 = int(square_size*(i+1))
            if y1 == y2: y2 = y1+1
            x1 = int(square_size*j)
            x2 = int(square_size*(j+1))
            if x1 == x2: x2 = x1+1
            
            #priemerujeme
            priemR = 0
            priemG = 0
            priemB = 0 
            vahaSucet = 0 
            for y in range(y1,y2):
                for x in range(x1,x2):
                    #Laplacian filter - detekcia hrany
                    pocSus = 0
                    sucR = 0; sucG = 0; sucB = 0;
                    for k in range(0,len(dx)):
                        if JeV(image.width(),image.height(),x+dx[k],y+dy[k]):
                           pocSus = pocSus + 1
                           color = QtGui.QColor(image.pixel(x+dx[k],y+dy[k]))
                           sucR = sucR + zn*color.red()
                           sucG = sucG + zn*color.green()
                           sucB = sucB + zn*color.blue()               
                    color = QtGui.QColor(image.pixel(x,y))
                    sucR = sucR - zn*pocSus*color.red() # varianta minus v strede = tmave ciary, varianta plus v strede = svetle ciary 
                    sucG = sucG - zn*pocSus*color.green()
                    sucB = sucB - zn*pocSus*color.blue()
                    r=int(sucR); g = int(sucG); b = int(sucB)
                    
                    if r > 255: r = 255
                    elif r < 0: r = 0
                    if g > 255: g = 255
                    elif g < 0: g = 0
                    if b > 255: b = 255
                    elif b < 0: b = 0
                    
                    #vypocet vahy pixela podla "svetlosti" pixela v obrazku upravenom laplacianovym filtrom 
                    vaha = int(0.21*r + 0.71*g + 0.07*b)*(max - min)/255 + min                 
                    
                    
                    priemR = priemR + vaha*color.red()
                    priemG = priemG + vaha*color.green()
                    priemB = priemB + vaha*color.blue()
                    vahaSucet = vahaSucet + vaha
                    
            if vahaSucet == 0: vahaSucet = 1       
            priemR = priemR//vahaSucet                 
            priemG = priemG//vahaSucet
            priemB = priemB//vahaSucet            
             
            priemRGB = QtGui.QColor(priemR,priemG,priemB).rgb()
            retImage.setPixel(j,i,priemRGB)
            
    print("koncim")      
    return retImage
     
       
    
################################################################################
# priradenie farieb    
    
def compute_pixel(old,new,old2,pomer):
    #print("pocitam pixel "+ str(pomer))

    color1 = QtGui.QColor(new)
    r1 = color1.red()
    g1 = color1.green()
    b1 = color1.blue()
    #print(str(r1)+" "+str(g1)+" "+str(b1))
    
    color2 = QtGui.QColor(old)
    r2 = color2.red()
    g2 = color2.green()
    b2 = color2.blue()
    #print(str(r2)+" "+str(g2)+" "+str(b2))
    differR = r2-r1 #stara minus nova
    differG = g2-g1
    differB = b2-b1             
    #print(str(differR)+" "+str(differG)+" "+str(differB))
    
    color3 = QtGui.QColor(old2)
    r3 = color3.red()
    g3 = color3.green()
    b3 = color3.blue()
    r = r3+int(differR*pomer)
    if(r < 0): r = 0
    if(r > 255): r = 255
    g = g3+int(differG*pomer)
    if(g < 0): g = 0
    if(g > 255): g = 255
    b = b3+int(differB*pomer)
    if(b < 0): b = 0
    if(b > 255): b = 255
    
    #print(str(r)+" "+str(g)+" "+str(b))
    
    color = QtGui.QColor(r,g,b)
    return color.rgb()   
    
def match_colors_dither_matrix(image,scale,scaleName,symbols,matrix,norm): #predpoklada sa, ze obrazok je uz spravnej velkosti
    pattern = Pattern(image.width(),image.height())
    x0 = -1
    for i in range(0,len(matrix[0])):
        if(matrix[0][i] == -1): x0 = i
    #print(x0)
    for y in range(0,image.height()):
        for x in range(0,image.width()):
            rgb = modifieColor(image.pixel(x,y))
            id = scale.getNearestNumToRGBColor(rgb)
            pattern.setSquare(x,y,id)    
            for i in range(x0+1,len(matrix[0])):
                if( JeV(image.width(),image.height(),x+(i-x0),y)):
                    rgb = compute_pixel(image.pixel(x,y),scale.getColor(id),image.pixel(x+(i-x0),y), float(matrix[0][i])/norm)
                    image.setPixel(x+(i-x0),y,rgb)
            for i in range(1,len(matrix)):    # y-ova suradnica 
                for j in range(0,len(matrix[i])):   #x-ova suradnica
                    if( JeV(image.width(),image.height(),x+(j-x0),y+i)):
                        rgb = compute_pixel(image.pixel(x,y),scale.getColor(id),image.pixel(x+(j-x0),y+i), float(matrix[i][j])/norm)
                        image.setPixel(x+(j-x0),y+i,rgb) 
            #print(str(x)+" "+str(y)+" "+str(id))                   
    return pattern    
    
class Riemersma_dithering():
    def __init__(self,image,base,palette,rules):
        
       self.errorR = 0
       self.errorG = 0
       self.errorB = 0
       self.x = 0
       self.y = 0
       self.Dx = {}
       self.Dy = {}
       self.Dx["u"] = 0  #vzdy x,y
       self.Dx["d"] = 0
       self.Dx["l"] = -1
       self.Dx["r"] = 1
       
       self.Dy["u"] = -1
       self.Dy["d"] = 1
       self.Dy["l"] = 0
       self.Dy["r"] = 0
       
       
       self.image = image
       self.palette = palette
       self.rules = rules
       
       self.pattern = Pattern(image.width(),image.height())
       
       roz = image.width() #potrebujem ten vacsi rozmer
       if(image.width() < image.height()): roz = image.height()                                     
       #najdem urovan:
       u = 0;
       pom = 1;
       while (pom < roz):
          u = u+1
          pom = pom*base
       #print("uroven= "+str(u))
       #prvy pixel
       color1 = QtGui.QColor(self.image.pixel(self.x,self.y))
       id = self.palette.getNearestNumToRGBColor(color1.rgb())
       color2 = QtGui.QColor(self.palette.getColor(id))
        
       
       self.errorR = color1.red() - color2.red()
       self.errorG = color1.green() - color2.green()
       self.errorB = color1.blue() - color2.blue()
       
       self.pattern.setSquare(0,0,id)
          
       self.curve(u,0)
       
       
       
    def curve(self, uroven, typ):
       if uroven == 0: return
       for i in range(0, len(self.rules[typ])):
          if(self.rules[typ][i].isdigit()):
              ntyp = int(self.rules[typ][i])
              self.curve(uroven-1,ntyp)
          else:
              self.x = self.x + self.Dx[self.rules[typ][i]]
              self.y = self.y + self.Dy[self.rules[typ][i]]
              
              #print(str(self.x)+" "+str(self.y))
              if JeV(self.image.width(),self.image.height(),self.x,self.y):
                  color = QtGui.QColor(self.image.pixel(self.x,self.y))
                  r = color.red() + self.errorR
                  g = color.green() + self.errorG
                  b = color.blue() + self.errorB
                  if(r < 0): r = 0
                  if(r > 255): r = 255
                  if(g < 0): g = 0
                  if(g > 255): g = 255
                  if(b < 0): b = 0
                  if(b > 255): b = 255 
                  
                  rgb = (QtGui.QColor(r,g,b)).rgb()
                  id = self.palette.getNearestNumToRGBColor(rgb) #najdem najblizsiu farbu
                  
                  self.pattern.setSquare(self.x,self.y,id)
                  
                  color = QtGui.QColor(self.palette.getColor(id)) #nova chyba
                  self.errorR = r-color.red()
                  self.errorG = g-color.green()
                  self.errorB = b-color.blue()
       return
       
    def getPattern(self):
       return self.pattern              
                  
class Riemersma_dithering2():
    def __init__(self,image,base,palette,rules,dlzkaError):
    
       self.dlzkaE = dlzkaError  
       self.errorR = []
       self.errorG = []
       self.errorB = []
       
       for i in range(0,dlzkaError):
           self.errorR.append(0)
           self.errorG.append(0)
           self.errorB.append(0)
       
       self.chybaKam = 0
       
       self.x = 0
       self.y = 0
       self.Dx = {}
       self.Dy = {}
       self.Dx["u"] = 0 
       self.Dx["d"] = 0
       self.Dx["l"] = -1
       self.Dx["r"] = 1
       
       self.Dy["u"] = -1
       self.Dy["d"] = 1
       self.Dy["l"] = 0
       self.Dy["r"] = 0
       
       
       self.image = image
       self.palette = palette
       self.rules = rules
       
       self.pattern = Pattern(image.width(),image.height())
       
       roz = image.width() #potrebujem ten vacsi rozmer
       if(image.width() < image.height()): roz = image.height()
                                     
       #najdem urovan:
       u = 0;
       pom = 1;
       while (pom < roz):
          u = u+1
          pom = pom*base
          
       #print("uroven= "+str(u))
       #prvy pixel      
       
       color1 = QtGui.QColor(self.image.pixel(self.x,self.y))
       id = self.palette.getNearestNumToRGBColor(color1.rgb())
       color2 = QtGui.QColor(self.palette.getColor(id))
        
       
       self.errorR[0] = color1.red() - color2.red()
       self.errorG[0] = color1.green() - color2.green()
       self.errorB[0] = color1.blue() - color2.blue()
       self.chybaKam = 1
       
       self.pattern.setSquare(0,0,id)
          
       self.curve(u,0)
       
       
       
    def curve(self, uroven, typ):
       if uroven == 0: return
       for i in range(0, len(self.rules[typ])):
          if(self.rules[typ][i].isdigit()):
              ntyp = int(self.rules[typ][i])
              self.curve(uroven-1,ntyp)
          else:
              self.x = self.x + self.Dx[self.rules[typ][i]]
              self.y = self.y + self.Dy[self.rules[typ][i]]
              
              sila = []
              pom = log(self.dlzkaE)/(self.dlzkaE-1)
              for s in range(0,self.dlzkaE):
                  sila.append(1/float(self.dlzkaE)*exp(pom*s))
              #print(str(self.x)+" "+str(self.y))
              if JeV(self.image.width(),self.image.height(),self.x,self.y):
                  eR = 0; eG = 0; eB = 0
                  for s in range(0,self.dlzkaE):
                      index = (s+ self.dlzkaE - self.chybaKam) % self.dlzkaE 
                      #print(str(s)+" "+str(sila[index]))
                      eR = eR + int(self.errorR[s]*sila[index])
                      eG = eG + int(self.errorG[s]*sila[index])
                      eB = eB + int(self.errorB[s]*sila[index])
                   
                  color = QtGui.QColor(self.image.pixel(self.x,self.y))
                  r = color.red() + eR
                  g = color.green() + eG
                  b = color.blue() + eB
                  if(r < 0): r = 0
                  if(r > 255): r = 255
                  if(g < 0): g = 0
                  if(g > 255): g = 255
                  if(b < 0): b = 0
                  if(b > 255): b = 255 
                  
                  rgb = (QtGui.QColor(r,g,b)).rgb()
                  id = self.palette.getNearestNumToRGBColor(rgb) #najdem najblizsiu farbu
                  
                  self.pattern.setSquare(self.x,self.y,id)
                  
                  color1 = QtGui.QColor(self.palette.getColor(id)) #nova chyba
                  self.errorR[self.chybaKam] = color.red()-color1.red()
                  self.errorG[self.chybaKam] = color.green()-color1.green()
                  self.errorB[self.chybaKam] = color.blue()-color1.blue()
                  self.chybaKam = (self.chybaKam + 1) % self.dlzkaE
                  
                  #print(self.errorR)
                  #print(self.errorG)
                  #print(self.errorB)
       return
       
    def getPattern(self):
       return self.pattern                  
                   
                 
if __name__ == '__main__':	
	
    import sys
    
    image = QtGui.QImage("stetec.png")
    calc = method2(image,"ariadna",5,5,{})
    #calc.chooseColors()
    #calc.colorMatch()                                                                      