from PySide import QtCore, QtGui
from Miniature import *
from UsedColors import *

class AbstractLeftWidget(QtGui.QWidget):
    def __init_(self,parent):
        self.parent = parent
        self.selectedColor = (None,None)
    
    def setColorFromDialog(self):
        dialog = ColorDialog(self.selectedColor)
        dialog.exec_()
        self.setColor(dialog.getColor())        
        
    def setColor(self,color):
        self.selectedColor = color
        if self.selectedColor[0] == None:
            image = QtGui.QImage(1,1, QtGui.QImage.Format_ARGB32)
            image.setPixel(0,0, (QtGui.QColor(255,255,255)).rgb())
            image = image.scaled(15*image.size())
            dialog = QtGui.QIcon(QtGui.QPixmap.fromImage(image))
            self.klikButton.setIcon(dialog)
            self.klikButton.setText("No fill") 
        else:
            image = QtGui.QImage(1,1, QtGui.QImage.Format_ARGB32)
            image.setPixel(0,0, self.selectedColor[1])
            image = image.scaled(15*image.size())
            dialog = QtGui.QIcon(QtGui.QPixmap.fromImage(image))
            self.klikButton.setIcon(dialog)
            self.klikButton.setText(str(self.selectedColor[0][0])+" "+str(self.selectedColor[0][1]))
    
    def changeColor(self):
        self.parent.selectedToColor(self.selectedColor[0])    
        

class ImageLeftWidget(AbstractLeftWidget):

    def __init__(self,parent):
        super(ImageLeftWidget, self).__init__()
        self.parent = parent
        self.miniature = Miniature(self.parent)
        self.selectedColor = (None,None)
        
        image = QtGui.QImage(1,1, QtGui.QImage.Format_ARGB32)
        image.setPixel(0,0, (QtGui.QColor(255,255,255)).rgb())
        image = image.scaled(15*image.size())
        
        dialog = QtGui.QIcon(QtGui.QPixmap.fromImage(image))
        stetec = QtGui.QIcon(QtGui.QPixmap.fromImage(QtGui.QImage("stetec.png")))
        self.klikButton = QtGui.QPushButton(dialog,"No fill",self)
        QtCore.QObject.connect(self.klikButton, QtCore.SIGNAL('clicked()'), self.setColorFromDialog)
        self.paintButton = QtGui.QPushButton(stetec,"",self)
        QtCore.QObject.connect(self.paintButton,QtCore.SIGNAL('clicked()'), self.changeColor)
        
        self.usedColors = QtGui.QWidget()                
        self.scrollArea = QtGui.QScrollArea(self)
        self.scrollArea.setWidget(self.usedColors)
        
        self.gridLayout2 = QtGui.QGridLayout()
        self.gridLayout2.addWidget(self.klikButton, 0,0)
        self.gridLayout2.addWidget(self.paintButton, 0,1)
        self.gridLayout2.addLayout(QtGui.QVBoxLayout(),0,2)
        self.gridLayout2.setColumnStretch(2,200)
        
        self.layout = QtGui.QGridLayout(self)
        self.layout.addWidget(self.miniature,0,0)
        self.layout.addLayout(self.gridLayout2, 1,0)
        self.layout.addWidget(self.scrollArea, 2,0)
        self.layout.setRowStretch(2,200)
        self.layout.setRowMinimumHeight(0, 188)
        self.layout.setColumnMinimumWidth(0, 250)
        
        self.setLayout(self.layout)
        
class OwnLeftWidget(AbstractLeftWidget):

    def __init__(self,parent):
        super(OwnLeftWidget, self).__init__()
        self.parent = parent
        self.selectedColor = (None,None)
        
        image = QtGui.QImage(1,1, QtGui.QImage.Format_ARGB32)
        image.setPixel(0,0, (QtGui.QColor(255,255,255)).rgb())
        image = image.scaled(15*image.size())
        
        dialog = QtGui.QIcon(QtGui.QPixmap.fromImage(image))
        stetec = QtGui.QIcon(QtGui.QPixmap.fromImage(QtGui.QImage("stetec.png")))
        self.klikButton = QtGui.QPushButton(dialog,"No fill",self)
        QtCore.QObject.connect(self.klikButton, QtCore.SIGNAL('clicked()'), self.setColorFromDialog)
        self.paintButton = QtGui.QPushButton(stetec,"",self)
        QtCore.QObject.connect(self.paintButton,QtCore.SIGNAL('clicked()'), self.changeColor)
        
        self.usedColors = QtGui.QWidget()                
        self.scrollArea = QtGui.QScrollArea(self)
        self.scrollArea.setWidget(self.usedColors)
        
        self.gridLayout2 = QtGui.QGridLayout()
        self.gridLayout2.addWidget(self.klikButton, 0,0)
        self.gridLayout2.addWidget(self.paintButton, 0,1)
        self.gridLayout2.addLayout(QtGui.QVBoxLayout(),0,2)
        self.gridLayout2.setColumnStretch(2,200)
        
        self.layout = QtGui.QGridLayout(self)
        self.layout.addLayout(self.gridLayout2, 0,0)
        self.layout.addWidget(self.scrollArea, 1,0)
        self.layout.setRowStretch(1,200)
        self.layout.setColumnMinimumWidth(0, 250)
        
        self.setLayout(self.layout)           