from PySide import QtCore, QtGui
from PatternWidget import *
from Constants import *
      
class Needle(QtGui.QMainWindow):	
    def __init__(self):	   
        super(Needle, self).__init__()
        
        self.path = "" #miesto kam ukladam predlohu       
        self.saved = 1  # tato premenna hovori, ci zbehlo Save As... pri obycajnom Save to nehra rolu 
	
        self.menuBar = QtGui.QMenuBar(self)
        self.setMenuBar(self.menuBar)
        
        #self.PatternWidget = QtGui.QWidget(self)
        self.PatternWidget = AbstractPatternWidget()
        self.PatternWidget.setDisabled(1)
        self.setCentralWidget(self.PatternWidget)
        
        #self.layout = QtGui.QGridLayout(self)
        #self.layout.setMenuBar(self.menuBar)
        #self.layout.addWidget(self.PatternWidget,0,0)

        self.resize(1000,600)
        #self.setLayout(self.layout)
        self.createActions()
        self.createMenus()
        self.setWindowTitle("Needle")
        ikona = QtGui.QImage("ikona.png")
        self.setWindowIcon(QtGui.QIcon(QtGui.QPixmap.fromImage(ikona)))
        
        
    def OpenPatternFromFile(self):    
        fileName = QtGui.QFileDialog.getOpenFileName(self, "Open File",QtCore.QDir.currentPath(), "Patterns (*.pt)" )
        if fileName:
            file = fileName[0]
            if file == "":
                sprava = "Cannot load "+str(fileName)
                QtGui.QMessageBox.information(self, "Needle",	sprava)
                return 
            vstup = open(file)
            a = vstup.read()
            a = a.split("\n")
            self.PatternWidget.setDisabled(0)
            if(int(a[0]) == NUMBER_OF_IMAGE_PATTERN()):
                 self.PatternWidget = ImagePatternWidget()
                 self.setCentralWidget(self.PatternWidget)
                 file = file.rstrip(".pt")
                 self.path = file
                 self.PatternWidget.setImage(self.path,a[1])
                 self.PatternWidget.OpenFrom(file)
            elif(int(a[0]) ==NUMBER_OF_OWN_PATTERN()):
                 self.PatternWidget = OwnPatternWidget()
                 self.setCentralWidget(self.PatternWidget)
                 file = file.rstrip(".pt")
                 self.path = file
                 self.PatternWidget.OpenFrom(file)      
    
    def openPattern(self): 
        if(self.PatternWidget.modified != 0):
            msgBox = QtGui.QMessageBox()
            msgBox.setText("The pattern has been modified.")
            msgBox.setInformativeText("Do you want to save your changes?")
            msgBox.setStandardButtons(QtGui.QMessageBox.Save | QtGui.QMessageBox.Discard | QtGui.QMessageBox.Cancel)
            msgBox.setDefaultButton(QtGui.QMessageBox.Save)
            ret = msgBox.exec_()
                
            if ret == QtGui.QMessageBox.Save: #najprv sa ulozi
                self.savePattern()
                if(self.saved == 1): self.OpenNewPattern() # otvorim len ak sa save-ol ten predchadzajuci    
            elif ret == QtGui.QMessageBox.Discard: 
                self.OpenNewPattern() #otvorim bez save-ovania
            elif ret == QtGui.QMessageBox.Cancel: #nic sa nestane
                pass
            else:
                pass
        else:
            self.OpenPatternFromFile()                    
    
        
    def saveAsPattern(self): #ukladanie pattern 
        self.saved = 0
        fileName = QtGui.QFileDialog.getSaveFileName(self, "Open File",QtCore.QDir.currentPath(), "Patterns (*.pt)" )
        if fileName:
            file = fileName[0]
            if file == "":
                sprava = "Cannot save as "+str(fileName)
                QtGui.QMessageBox.information(self, "Needle",	sprava)
                return
            self.path = file.rstrip(".pt") # odstrani priponu .pt ... aby som mohla vytvorit vela roznych suborov s rovnakym menom len inou priponou     
            self.PatternWidget.SaveTo(self.path) #uloženie do suborov
            self.saved = 1
            
    def savePattern(self):
        if(self.path != ""): self.PatternWidget.SaveTo(self.path)  #staci ulozit na existujucu adresu
        else: self.saveAsPattern()  #najprv si vypytam adresu a potom ulozim        
    
    
    def closeEvent(self,event):
        if(self.PatternWidget.modified != 0):
            msgBox = QtGui.QMessageBox()
            msgBox.setText("The pattern has been modified.")
            msgBox.setInformativeText("Do you want to save your changes?")
            msgBox.setStandardButtons(QtGui.QMessageBox.Save | QtGui.QMessageBox.Discard | QtGui.QMessageBox.Cancel)
            msgBox.setDefaultButton(QtGui.QMessageBox.Save)
            ret = msgBox.exec_()
                
            if ret == QtGui.QMessageBox.Save: #najprv sa ulozi  potom vypne
                self.savePattern()
                if(self.saved == 1): event.accept()
                else: event.ignore()    
            elif ret == QtGui.QMessageBox.Discard: #iba vypne
                event.accept()
            elif ret == QtGui.QMessageBox.Cancel: # nevypne
                event.ignore()
            else:
                pass      
     
    def CreateNewIPattern(self):       
        fileName = QtGui.QFileDialog.getOpenFileName(self,
                  "Open Image", QtCore.QDir.currentPath(), "Image Files (*.png *.jpg *.bmp)")
        if fileName:
            image = QtGui.QImage(fileName[0])
            if image.isNull():
                sprava = "Cannot load "+str(fileName)
                QtGui.QMessageBox.information(self, "Needle",	sprava)
                return
            a = fileName[0].split(".")
            print(a)
            type = a[len(a)-1]
            file = fileName[0].rstrip("."+type)            
            self.path = ""          
            self.PatternWidget.setDisabled(0)
            self.PatternWidget = ImagePatternWidget()        
            self.setCentralWidget(self.PatternWidget) 
            self.PatternWidget.setImage(file,type)   
        
    def NewIPattern(self):
        #print("som tu")
        if(self.PatternWidget.modified != 0):
            msgBox = QtGui.QMessageBox()
            msgBox.setText("The pattern has been modified.")
            msgBox.setInformativeText("Do you want to save your changes?")
            msgBox.setStandardButtons(QtGui.QMessageBox.Save | QtGui.QMessageBox.Discard | QtGui.QMessageBox.Cancel)
            msgBox.setDefaultButton(QtGui.QMessageBox.Save)
            ret = msgBox.exec_()
                
            if ret == QtGui.QMessageBox.Save: #najprv sa ulozi
                self.savePattern()  
                if(self.saved == 1): self.CreateNewIPattern()  #vyrobim novy ... ale iba ak sa naozaj ulozilo   
            elif ret == QtGui.QMessageBox.Discard: #neulozi sa len sa pokračuje
                self.CreateNewIPattern() #iba vyrobim novy
            elif ret == QtGui.QMessageBox.Cancel: # neurobi to nic
                #print("cancel was clicked")
                pass
            else:
                #print("should never be reached")
                pass
        else: self.CreateNewIPattern() #nic nebolo modifikovane... mozem urobit novy priamo        
        
        
    def CreateNewOPattern(self):
        self.path = ""; 
        self.PatternWidget.setDisabled(0)
        self.PatternWidget = OwnPatternWidget()
        self.setCentralWidget(self.PatternWidget)   
        
    def NewOPattern(self):
        #print("som tu")
        if(self.PatternWidget.modified != 0):
            msgBox = QtGui.QMessageBox()
            msgBox.setText("The pattern has been modified.")
            msgBox.setInformativeText("Do you want to save your changes?")
            msgBox.setStandardButtons(QtGui.QMessageBox.Save | QtGui.QMessageBox.Discard | QtGui.QMessageBox.Cancel)
            msgBox.setDefaultButton(QtGui.QMessageBox.Save)
            ret = msgBox.exec_()
                
            if ret == QtGui.QMessageBox.Save: #najprv sa ulozi
                self.savePattern() 
                if(self.saved == 1): self.CreateNewOPattern()  #vyrobim novy   
            elif ret == QtGui.QMessageBox.Discard: #neulozi sa len sa pokračuje
                self.CreateNewOPattern() #iba vyrobim novy
            elif ret == QtGui.QMessageBox.Cancel: # neurobi to nic
                pass
            else:
                pass
                
        else: self.CreateNewOPattern() #nic nebolo modifikovane... mozem urobit novy priamo       
     
     
            
    def exportToLaTeX(self): 
        if(self.path == ""): self.saveAsPattern() # nie je ulozene, tak najprv ulozim
        if(self.saved == 1): self.PatternWidget.Export(self.path) # ak sa naozaj ulozilo, tak exportujem          	          
                              
            
    def createActions(self):
        self.NewImagePattern = QtGui.QAction("New Pattern from image...",self, shortcut="Ctrl+I", 
                triggered=self.NewIPattern)
                
        self.NewOwnPattern = QtGui.QAction("New own Pattern...", self, shortcut="Ctrl+P", #??????? 
                triggered=self.NewOPattern)
                        
        self.saveAsAct = QtGui.QAction("&Save as...", self, shortcut="F12",
                triggered=self.saveAsPattern) 
                
        self.saveAct = QtGui.QAction("&Save...", self, shortcut="Ctrl+S",
                triggered=self.savePattern)        
        
        self.openAct = QtGui.QAction("&Open &pattern...", self, shortcut="Ctrl+O",
                triggered=self.openPattern)               	
	
        self.exportAct = QtGui.QAction("&Export &pattern...", self, shortcut="Ctrl+E",
                triggered=self.exportToLaTeX) 	      
	
        self.exitAct = QtGui.QAction("E&xit", self, shortcut="Ctrl+Q",	
                triggered=self.close)	
	
	
        self.aboutQtAct = QtGui.QAction("About &Qt", self,	
                triggered=QtGui.qApp.aboutQt)
	
    def createMenus(self):	
        self.fileMenu = QtGui.QMenu("&File", self)	
        self.fileMenu.addAction(self.NewImagePattern)
        self.fileMenu.addAction(self.NewOwnPattern)
        self.fileMenu.addAction(self.saveAsAct)
        self.fileMenu.addAction(self.saveAct)
        self.fileMenu.addAction(self.openAct)
        self.fileMenu.addAction(self.exportAct)		
        self.fileMenu.addSeparator()	
        self.fileMenu.addAction(self.exitAct)	
	
        self.helpMenu = QtGui.QMenu("&Help", self)		
        self.helpMenu.addAction(self.aboutQtAct)	
        	
        self.menuBar.addMenu(self.fileMenu)	
        self.menuBar.addMenu(self.helpMenu)         	     
                                   		
if __name__ == '__main__':	
	
    import sys	
	
    app = QtGui.QApplication(sys.argv)	
    needle = Needle()	
    needle.show()	
    sys.exit(app.exec_())                       