from Constants import *
from PySide import QtCore, QtGui

class Pattern():
    def __init__(self,width,height):
        self.pattern = []  #predloha
        
        self.width = width  #rozmery
        self.height = height
        
        self.colorSymbol = {} #značky
        self.colorCount = {}  #pocet
        
        # vyrobim zatial cistu predlohu zadanych rozmerov
        for i in range(0,self.height): 
            self.pattern.append([])
            for j in range(0,self.width):
                self.pattern[i].append(None)                     
                
    def getHeight(self): # vrati vysku
        return self.height
        
    def getWidth(self): # vrati sirku
        return self.width 
        
    def getSquare(self,x,y): # vrati cislo farby na stvorceku
        if((x >= 0) and (x < self.width) and (y >=0) and (y < self.height)): return self.pattern[y][x]
        else: return -1 # ak som dostala zle suradnice 
        
    def getColorSymbol(self,id): #vrati symbol pre farbu
        if(id in self.colorSymbol.keys()): return self.colorSymbol[id]
        else: return None
        
    def getColorCount(self,id):  #vrati pocet stvorcekov danej farby
        if(id in self.colorCount.keys()): return self.colorCount[id]
        else: return 0
    
    def getColors(self): # vrati mnozinu farieb pouzitych v predlohe
        return self.colorSymbol.keys()
    
    def getColorToSym(self):
        return self.colorSymbol           
        
    def setSquare(self,x,y,id): # nastavy stvorcek na danu farbu, automaticky spravi zmeny v poctoch a znackach
        #otestujem spravne suradnice
        if((x >= 0) and (x < self.width) and (y >=0) and (y < self.height)):
            old = self.pattern[y][x]
            #print(str(old)+" "+str(x)+" "+str(y)+" "+str(id))
            self.pattern[y][x] = id
            
            # mazem povodnu
            oldSymbol = None
            oldCount = 0
                              
            if(old != None): #nejaka farba tam bol
                oldSymbol = self.colorSymbol[old] #v pripade, ze mazem farbu uplne, ale nakoniec sa vymena nevykona
                oldCount = self.colorCount[old]
            
                self.colorCount[old] = self.colorCount[old]-1
                if(self.colorCount[old] == 0): #dana farba sa tam uz nenachadza
                    # zmazem o nej zaznam 
                    try:                             
                        del self.colorCount[old]
                    except KeyError:
                        pass
                    try:                            
                        del self.colorSymbol[old]
                    except KeyError:
                        pass    
            
            #davam novu farbu         
            if(id == None): return # davam tam nic                  
            elif(id in self.colorCount.keys()): # farba sa tam nachadza - len jej zvacsim pocitadlo 
                self.colorCount[id] = self.colorCount[id]+1               
            else:                   # nova farba
                if(len(self.colorCount) < MAX_COLORS_COUNT()):
                    self.colorCount[id] = 1
                    symbol = self.findNewSymbol()
                    self.colorSymbol[id] = symbol # nastavim jej nepouzity symbol
                else:  #nie je ziadna nova znacka -> nebudem nic menit, len vratim povodnu farbu
                    self.pattern[y][x] = old 
                    self.colorSymbol[old] = oldSymbol 
                    self.colorCount[old] = oldCount      
                    QtGui.QMessageBox.information(self, "Needle",	"Neexistuje znak pre novú farbu")
                    return          
                        
    def findNewSymbol(self): # najde nejaku volnu znacku, ak nenajde vrati None
        for i in range(1,MAX_COLORS_COUNT()+1):
            if i not in self.colorSymbol.values():
                return i
        return None                                            
    
    def symbolIsUsed(self,sym):   # zisti, ci dana znacka je pouzita
        if sym in self.colorSymbol.values():
            return True
        else: return False                
                
    def setSymbol(self,id,sym): # ak je zadany symbol obsadeny, tak zadany symbol a povodny symbol farby id vymeni... inak jednoducho priradi
        #testovanie opravnenie poziadavky: novy znak je platny a farba sa nachadza v predlohe 
        if((id in self.colorCount.keys()) and (sym >= 0) and (sym < MAX_COLORS_COUNT())):
            if( self.symbolIsUsed(sym)): # je pouzity -> symboly vymenim
                pomID = 0
                for i in self.colorSymbol.keys(): # hladanie farby s pozadovanym symbolom
                    if(self.colorSymbol[i] == sym):
                        pomID = i
                self.colorSymbol[pomID] = self.colorSymbol[id] #vymena farieb
                self.colorSymbol[id] = sym
            else: # nic nam nebrani ten symbol pouzit            
                self.colorSymbol[id] = sym                                                      