from PySide import QtCore, QtGui

class PatternLabel(QtGui.QWidget):
     def __init__(self,parent):
        super(PatternLabel, self).__init__()
        self.parent = parent
        self.SquareSize = 10;
        self.image = QtGui.QImage()
        self.resize(0,0)
        
        self.tahamZ = QtCore.QPoint()
        self.tahamK = QtCore.QPoint()
        self.taham = False
        
        self.timer = QtCore.QTimer()
        self.timer.setInterval(100)
        self.connect(self.timer, QtCore.SIGNAL("timeout()"), self.updatePosition)
        self.zmenaX = 0
        self.zmenaY = 0
        
        self.setFocusPolicy(QtCore.Qt.ClickFocus)
        self.setFocus(QtCore.Qt.OtherFocusReason)
        self.zbieraj = False
        self.oznacene = []
      
     def editRect(self,p1,p2):
        x1 = p1.x()
        x2 = p2.x()
        if p1.x() > p2.x(): 
            x1 = p2.x()
            x2 = p1.x()
        x1 = x1 // self.SquareSize
        x2 = (x2 // self.SquareSize)+1
        
        y1 = p1.y()
        y2 = p2.y()
        if p1.y() > p2.y(): 
            y1 = p2.y()
            y2 = p1.y()
        y1 = y1 // self.SquareSize
        y2 = (y2 // self.SquareSize)+1
        return [x1,y1,x2,y2]          
           
     def horizontalPosition(self,x):
        val = (self.parent.patternScrollArea.horizontalScrollBar()).sliderPosition()
        minimum = (self.parent.patternScrollArea.horizontalScrollBar()).minimum()
        maximum = (self.parent.patternScrollArea.horizontalScrollBar()).maximum()
        pageStep = (self.parent.patternScrollArea.horizontalScrollBar()).pageStep()
        w = maximum - minimum + pageStep
        x1 = (self.width()*val)//w
        x2 = (self.width()*(val+pageStep))//w
        if x < x1 : return x-x1
        elif x >= x1 and x <= x2: return 0
        else: return x-x2  
        
     def verticalPosition(self,y):   
        val = (self.parent.patternScrollArea.verticalScrollBar()).sliderPosition()
        minimum = (self.parent.patternScrollArea.verticalScrollBar()).minimum()
        maximum = (self.parent.patternScrollArea.verticalScrollBar()).maximum()
        pageStep = (self.parent.patternScrollArea.verticalScrollBar()).pageStep()
        h = maximum - minimum + pageStep
        y1 = (self.height()*val)//h
        y2 = (self.height()*(val+pageStep))//h
        if y < y1 : return y-y1
        elif y >= y1 and y <= y2: return 0
        else: return y-y2
        
     def move(self,pos): 
        #print(str(self.verticalPosition(pos.y()))+" "+str(self.horizontalPosition(pos.x())))
        minimum = (self.parent.patternScrollArea.verticalScrollBar()).minimum()
        maximum = (self.parent.patternScrollArea.verticalScrollBar()).maximum()
        pageStep = (self.parent.patternScrollArea.verticalScrollBar()).pageStep()
        h = maximum - minimum + pageStep 
        spustilo = False
        
        self.zmenaX = self.horizontalPosition(pos.x())
        self.zmenaY = self.verticalPosition(pos.y())
        
        if self.verticalPosition(pos.y()) < 0:
            self.timer.start()
            spustilo = True  
            newval = (h*pos.y())//self.height()
            val = max(newval,0)
            if val == 0: self.zmenaY = 0
            (self.parent.patternScrollArea.verticalScrollBar()).setValue(val)
        elif self.verticalPosition(pos.y()) > 0:
            self.timer.start()
            spustilo = True
            maximum = (self.parent.patternScrollArea.verticalScrollBar()).maximum()
            newval = (h*pos.y())//self.height() - pageStep
            val = min(newval,maximum) 
            if val == maximum: self.zmenaY = 0
            (self.parent.patternScrollArea.verticalScrollBar()).setValue(val)
            
        minimum = (self.parent.patternScrollArea.horizontalScrollBar()).minimum()
        maximum = (self.parent.patternScrollArea.horizontalScrollBar()).maximum()
        pageStep = (self.parent.patternScrollArea.horizontalScrollBar()).pageStep()
        w = maximum - minimum + pageStep
        if self.horizontalPosition(pos.x()) < 0:
            self.timer.start() 
            spustilo = True 
            newval = (w*pos.x())//self.width()
            val = max(newval,0)
            if val == 0: self.zmenaX = 0
            (self.parent.patternScrollArea.horizontalScrollBar()).setValue(val)
        elif self.horizontalPosition(pos.x()) > 0:
            self.timer.start() 
            spustilo = True
            maximum = (self.parent.patternScrollArea.horizontalScrollBar()).maximum()
            newval = (w*pos.x())//self.width() - pageStep
            val = min(newval,maximum)
            if val == maximum: self.zmenaX = 0
            (self.parent.patternScrollArea.horizontalScrollBar()).setValue(val)
        if not spustilo: self.timer.stop()    
            
     def updatePosition(self):
         x = self.tahamK.x()+self.zmenaX
         y = self.tahamK.y()+self.zmenaY
         print("timer")
         self.tahamK = QtCore.QPoint(x,y)
         self.move(self.tahamK)
         self.repaint()                        
     
     def moveEvent(self,event):
        self.parent.update();
        
     def mousePressEvent(self,event):
        print("klik sem:"+str((event.pos()).x())+" "+str((event.pos()).y()))
        if not self.zbieraj: self.oznacene = []
        self.tahamZ = event.pos()
        self.tahamK = event.pos()
        self.mousePos = event.pos() 
        self.taham = True
        self.timer.start()
        
     def mouseReleaseEvent(self,event):     
        print("klik od:"+str((event.pos()).x())+" "+str((event.pos()).y()))
        self.tahamK = event.pos()
        self.mousePos = event.pos()
        self.taham = False
        self.timer.stop()
        if not self.zbieraj: 
           self.oznacene = []
        edit = self.editRect(self.tahamZ,self.tahamK)
        self.oznacene.append(edit)
        self.repaint()
        
     def mouseMoveEvent(self,event):
        if self.taham:
            self.tahamK = event.pos()
            self.mousePos = event.pos()
            self.move(event.pos())            
            self.repaint()  
            
     def keyPressEvent(self,event):
        if event.key() == QtCore.Qt.Key_Control:
            print("zbieraj")
            self.zbieraj = True
            
     def keyReleaseEvent(self,event):
        if event.key() == QtCore.Qt.Key_Control:
            print("nezbieraj")
            self.zbieraj = False              
        
     def adjustSize(self):  
        Iy = self.image.height()
        Ix = self.image.width()
        width = Ix*self.SquareSize+1
        if Ix % 10 == 0 : width = width +1
        height = Iy*self.SquareSize+1
        if Iy % 10 == 0 : height = height +1 
        self.resize(width,height) 
        
     def setImage(self,image):
        self.image = image 
        self.adjustSize() 
        
     def getSelected(self):
        return self.oznacene 
     
     def setSelected(self,s):
        self.oznacene = s
        self.repaint()        
        
     def paintEvent(self, event):
        Iy = self.image.height()
        Ix = self.image.width()
        self.adjustSize()
        #self.resize(Ix*self.SquareSize+1,Iy*self.SquareSize+1)
        
        image = self.image.scaled(self.SquareSize*self.image.size())
        qp = QtGui.QPainter()
        qp.begin(self)
        qp.setPen(QtGui.QColor(100,100,100))
        qp.drawImage(QtCore.QPoint(0,0),image)
        for y in range(0,Iy+1):
            if self.SquareSize>5: 
                qp.drawLine(0,y*self.SquareSize, Ix*self.SquareSize+1,y*self.SquareSize)
                if y % 10 == 0: qp.drawLine(0,y*self.SquareSize+1, Ix*self.SquareSize+1,y*self.SquareSize+1)
            elif self.SquareSize > 2 and self.SquareSize <= 5 and y % 10 == 0:
                qp.drawLine(0,y*self.SquareSize, Ix*self.SquareSize+1,y*self.SquareSize)     
        for x in range(0,Ix+1):
            if self.SquareSize > 5:
                qp.drawLine(x*self.SquareSize, 0 ,x*self.SquareSize,Iy*self.SquareSize+1)
                if x % 10 == 0: qp.drawLine(x*self.SquareSize+1, 0 ,x*self.SquareSize+1,Iy*self.SquareSize+1)
            elif self.SquareSize > 2 and self.SquareSize <= 5 and x % 10 == 0:
                qp.drawLine(x*self.SquareSize, 0 ,x*self.SquareSize,Iy*self.SquareSize+1)
        
        for i in range(0,len(self.oznacene)):
            color = QtGui.QColor(0,0,200,100)
            edit = self.oznacene[i]
            qp.fillRect(edit[0]*self.SquareSize, edit[1]*self.SquareSize, (edit[2] - edit[0])*self.SquareSize, (edit[3]-edit[1])*self.SquareSize,color)         
                
        if self.taham:
            color = QtGui.QColor(0,0,200,100)
            edit = self.editRect(self.tahamZ,self.tahamK) 
            qp.fillRect(edit[0]*self.SquareSize, edit[1]*self.SquareSize, (edit[2] - edit[0])*self.SquareSize, (edit[3]-edit[1])*self.SquareSize,color)                 
        qp.end()   