from PySide import QtCore, QtGui
from CalculatingMethods import *
        
class ImageSettingsWidget(QtGui.QWidget):

    def __init__(self, parent):	   
        super(ImageSettingsWidget, self).__init__()
        self.parent = parent 
        self.image = QtGui.QImage()        
        
        self.width =  QtGui.QRadioButton("width",self)
        self.width.setChecked(1)
        self.height = QtGui.QRadioButton("height",self)
        self.sizeEdit = QtGui.QSpinBox(self)
        self.sizeEdit.setMaximum(300)
        self.sizeEdit.setMinimum(3)        
        
        self.colorPaletteLabel = QtGui.QLabel("color palette:",self)
        self.colorPaletteEdit = QtGui.QComboBox(self)
        self.colorPaletteEdit.insertItem(0,"ariadna")
        self.colorPaletteEdit.insertItem(1,"anchor")
        
        self.maxLabel = QtGui.QLabel("Max color count:",self)
        self.maxEdit = QtGui.QSpinBox(self)
        self.maxEdit.setMinimum(1)
        self.maxEdit.setMaximum(60) #iba dočasne
        
        self.methodLabel = QtGui.QLabel("Method:",self)
        self.choosePalette = QtGui.QComboBox(self)
        self.choosePalette.insertItem(0,"jednoducho")
        self.choosePalette.insertItem(1,"vylepsene")
        self.choosePalette.insertItem(2,"rozdelovanie")
        
        self.resizeLabel1 = QtGui.QLabel("highlight edges: light",self)
        self.resizeSlider = QtGui.QSlider(QtCore.Qt.Horizontal)
        self.resizeSlider.setMinimum(-5)
        self.resizeSlider.setMaximum(5)
        self.resizeSlider.setValue(0)
        self.resizeSlider.setMaximumWidth(100)
        self.resizeSlider.setMinimumWidth(100)
        self.resizeLabel2 = QtGui.QLabel("dark",self)
        
                
        self.methodEdit = QtGui.QComboBox(self)
        self.methodEdit.insertItem(0,"obycajne")
        self.methodEdit.insertItem(1,"Floyd-Steinberg dithering") 
        self.methodEdit.insertItem(2,"'false' Floyd-Steinberg")
        self.methodEdit.insertItem(3,"Jarvis,Judice,Ninke")
        self.methodEdit.insertItem(4,"Stucki")
        self.methodEdit.insertItem(5,"Burkes")
        self.methodEdit.insertItem(6,"Atkinson")
        self.methodEdit.insertItem(7,"Sierra3")
        self.methodEdit.insertItem(8,"Sierra2")
        self.methodEdit.insertItem(9,"Sierra2-4A")
        self.methodEdit.insertItem(10,"Stevenson-Arce")
        self.methodEdit.insertItem(11,"Riemersma-Hilbert")
        self.methodEdit.insertItem(12,"Riemersma-Pean")
        self.methodEdit.insertItem(13,"Riemersma2-Hilbert")
        self.methodEdit.insertItem(14,"Riemersma2-Pean")
        
        self.dobutton = QtGui.QPushButton("Do", self)
        QtCore.QObject.connect(self.dobutton, QtCore.SIGNAL('clicked()'), self.do)
        
        self.gridLayout = QtGui.QGridLayout(self)        
        self.gridLayout.addWidget(self.width, 0,0)
        self.gridLayout.addWidget(self.height, 0,1)
        self.gridLayout.addWidget(self.sizeEdit, 0,2)
        self.gridLayout.addWidget(self.colorPaletteLabel, 0,3)
        self.gridLayout.addWidget(self.colorPaletteEdit, 0,4)
        self.gridLayout.addWidget(self.maxLabel,0,5)
        self.gridLayout.addWidget(self.maxEdit,0,6)
        self.gridLayout.addWidget(self.methodLabel,0,7)
        self.gridLayout.addWidget(self.choosePalette,0,8)
        self.gridLayout.addWidget(self.resizeLabel1,0,9)
        self.gridLayout.addWidget(self.resizeSlider,0,10)
        self.gridLayout.addWidget(self.resizeLabel2,0,11)
        self.gridLayout.addWidget(self.methodEdit,0,12)
        self.gridLayout.addWidget(self.dobutton, 0,13)
        self.setLayout(self.gridLayout)
        
    def setImage(self,image):
        self.image = image     
                   
    def do(self): #spustim metodu s danymi parametrami. Nechám pattern Widget zobrazit vysledok
        if self.width.isChecked(): squareSize = self.image.width()/self.sizeEdit.value()
        else: squareSize = self.image.height()/self.sizeEdit.value()
        self.parent.do(self.colorPaletteEdit.currentText(),squareSize,self.maxEdit.value(), self.choosePalette.currentText(), self.resizeSlider.value(),self.methodEdit.currentText())                         
          
class OwnSettingsWidget(QtGui.QWidget):

    def __init__(self, parent):	   
        super(OwnSettingsWidget, self).__init__()          
        self.parent = parent
        
        self.widthLabel = QtGui.QLabel("width",self)
        self.widthEdit = QtGui.QSpinBox(self)
        self.widthEdit.setMaximum(300)
        self.widthEdit.setMinimum(10)
        self.heightLabel = QtGui.QLabel("height",self)
        self.heightEdit = QtGui.QSpinBox(self)
        self.heightEdit.setMaximum(300)
        self.heightEdit.setMinimum(10)
        self.dobutton = QtGui.QPushButton("Do", self)
        QtCore.QObject.connect(self.dobutton, QtCore.SIGNAL('clicked()'), self.do)
        
        self.gridLayout = QtGui.QGridLayout(self)        
        self.gridLayout.addWidget(self.widthLabel, 0,0)
        self.gridLayout.addWidget(self.widthEdit,0,1)
        self.gridLayout.addWidget(self.heightLabel, 0,2)
        self.gridLayout.addWidget(self.heightEdit, 0,3)
        self.gridLayout.addWidget(self.dobutton, 0,4)
        self.setLayout(self.gridLayout)
        
        for i in range(0,5):
            self.gridLayout.setColumnMinimumWidth(i,25) 
            
    def do(self):
        self.parent.do(self.widthEdit.value(),self.heightEdit.value())               