from PySide import QtCore, QtGui
import os
from ColorPalette import *
from Pattern import *
from Constants import *
from Dialogs import *
        
class UsedColors(QtGui.QWidget):
    def __init__(self,parent):
        super(UsedColors,self).__init__()

        self.parent = parent
        
        layout = QtGui.QGridLayout()
        i = 0
        self.colorLabels = []
        self.numberLabels = []
        self.brandLabels = []
        self.countSqLabels = []
        self.countSkLabels = []
        self.symbolLabels = []
        self.changeSymbolButtons = []
        self.selectColorButtons = []
        
        for col in self.parent.pattern.getColors():
            
            count = self.parent.pattern.getColorCount(col)
            color = self.parent.colorPaletts[col[1]].getColor(col)
        
            image = QtGui.QImage(1,1, QtGui.QImage.Format_ARGB32)
            image.setPixel(0,0, color)
            image = image.scaled(20*image.size())        
        
            colorLabel = QtGui.QLabel(str(color),self)
            colorLabel.setPixmap(QtGui.QPixmap.fromImage(image))
            self.colorLabels.append(colorLabel)
            
            numberLabel = QtGui.QLabel(col[0],self)
            self.numberLabels.append(numberLabel)
            
            brandLabel = QtGui.QLabel(col[1],self)
            self.brandLabels.append(brandLabel)            
            
            countSqLabel = QtGui.QLabel(str(count),self)
            self.countSqLabels.append(countSqLabel)
            
            countSkLabel = QtGui.QLabel(str(int((count+1)/SQUARECOUNT())+1),self)  #skein == klbko
            self.countSkLabels.append(countSkLabel)
            
            
            path = os.path.abspath(__file__) #cesta k prave vykonavanemu programu
            path = path.rstrip("UsedColors.py") #odstranenie nevhodneho konca
            symbol = "s"+'{:0>4}'.format(str(self.parent.pattern.getColorSymbol(col)))+".jpg"
            path = path + "symbols/"+symbol #prifarenie vhodneho
            image = QtGui.QImage(path)
            
            symbolLabel = QtGui.QLabel(str(self.parent.pattern.getColorSymbol(col)),self)
            symbolLabel.setPixmap(QtGui.QPixmap.fromImage(image))
            self.symbolLabels.append(symbolLabel)
            
            changeSymbol = QtGui.QIcon(QtGui.QPixmap.fromImage(QtGui.QImage("changeSymbol.png")))
            changeSymbolButton = NumButton(changeSymbol,"")
            changeSymbolButton.setSymbol(self.parent.pattern.getColorSymbol(col))
            changeSymbolButton.setNumber(col)
            self.changeSymbolButtons.append(changeSymbolButton)
            QtCore.QObject.connect(self.changeSymbolButtons[i], QtCore.SIGNAL('clicked()'), self.ChangeSymbol)
            
            selectColorButton = ColorButton((col,color))
            selectColorButton.setText("act.Col.")
            self.selectColorButtons.append(selectColorButton)
            QtCore.QObject.connect(self.selectColorButtons[i], QtCore.SIGNAL('clicked()'), self.setSelectedColor)
            
            layout.addWidget(colorLabel,i,0)
            layout.addWidget(numberLabel,i,1)
            layout.addWidget(brandLabel,i,2)
            layout.addWidget(countSqLabel,i,3)
            layout.addWidget(countSkLabel,i,4)
            layout.addWidget(symbolLabel,i,5)
            layout.addWidget(self.changeSymbolButtons[i],i,6)
            layout.addWidget(self.selectColorButtons[i],i,7)
            i = i+1
            
        self.setLayout(layout)            
        
    def ChangeSymbol(self):
        source = self.sender()
        dialog = SymbolDialog(source.getSymbol())
        a = dialog.exec_()
        if(a == 1):
            self.parent.pattern.setSymbol(source.getNumber(), dialog.getSymbol())
            print(str(source.getNumber())+" "+str(dialog.getSymbol()))
        self.parent.updatePattern()   
        
    def setSelectedColor(self):
        source = self.sender() 
        self.parent.leftWidget.setColor(source.getColor())     